<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE ARG SYSTEM "argument.dtd">
<ARG>
  <?Araucaria UTF-8?>
  <SCHEMESET>
    <SCHEME>
      <NAME>Probabilifying Conveyance Argument</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A makes B probable</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Sameness of Meaning</NAME>
      <FORM>
        <PREMISE>"A" means the same as "B"</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Singular Cause</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A causes B</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument to Common Cause</NAME>
      <FORM>
        <PREMISE>A is similar to B</PREMISE>
        <PREMISE>If A is similar to B and C caused A, then the similarity between A and B is caused by C’s causing both A and B</PREMISE>
        <PREMISE>C caused A</PREMISE>
        <CONCLUSION>C caused both A and B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Class-Membership Argument</NAME>
      <FORM>
        <PREMISE>A is an F</PREMISE>
        <PREMISE>All Fs are members of the class of Gs</PREMISE>
        <CONCLUSION>A is a G</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Species to Genus</NAME>
      <FORM>
        <PREMISE>A is a G</PREMISE>
        <PREMISE>Gs are a species of F</PREMISE>
        <CONCLUSION>A is an F</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument to Singular Cause</NAME>
      <FORM>
        <PREMISE>If A, then A is an effect of B</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Numerical Identity</NAME>
      <FORM>
        <PREMISE>A is numerically identical to B</PREMISE>
        <PREMISE>A is F</PREMISE>
        <CONCLUSION>B is F</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Causal Law</NAME>
      <FORM>
        <PREMISE>Facts of type F cause facts of type G</PREMISE>
        <PREMISE>A is a fact of type F</PREMISE>
        <CONCLUSION>Something is a G</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Concrete Facts.</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A constitutes the concrete fact that B</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Properties</NAME>
      <FORM>
        <PREMISE>If A, then A constitutes the fact that B is F</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>B is F</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Positive Normative Facts</NAME>
      <FORM>
        <PREMISE>B</PREMISE>
        <PREMISE>If B, then B constitutes the fact that A ought to be the case</PREMISE>
        <CONCLUSION>A ought to be the case</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Causal Laws</NAME>
      <FORM>
        <PREMISE>If A, then A constitutes the fact that it is a causal law that Fs are Gs</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>It is a causal law that Fs are Gs</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Implication</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>"A" logically implies "B"</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Negative Normative Facts</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A constitutes the fact that B should not be the case</PREMISE>
        <CONCLUSION>B should not be the case</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Constitution Facts</NAME>
      <FORM>
        <PREMISE>If A, then A constitutes the fact that if B, B constitutes the fact that C</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>If B, B constitutes the fact that C </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Necessary Conditions</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A constitutes the fact that B is a necessary condition for C</PREMISE>
        <CONCLUSION>B must obtain if C is to obtain</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Possibilities</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A constitutes the fact that it is possible that B</PREMISE>
        <CONCLUSION>It is possible that B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Singular Causal Conditionals</NAME>
      <FORM>
        <PREMISE>If A, then - A constitutes the fact that if B, B will cause C</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>If B, B will cause C</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Singular Causal Facts</NAME>
      <FORM>
        <PREMISE>C</PREMISE>
        <PREMISE>If C, then C constitutes the fact that A causes B</PREMISE>
        <CONCLUSION>A causes B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Kind Instance</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A constitutes a thing of kind F</PREMISE>
        <CONCLUSION>There is a thing of kind F</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Whole to Part</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then B is a part of A </PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Non-Causal Law</NAME>
      <FORM>
        <PREMISE>A is an F</PREMISE>
        <PREMISE>It is a non-causal law that Fs are Gs</PREMISE>
        <CONCLUSION>A is a G</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from the Constitution of Impossibilities</NAME>
      <FORM>
        <PREMISE>A</PREMISE>
        <PREMISE>If A, then A constitutes the fact that it is not possible that B</PREMISE>
        <CONCLUSION>It is not possible that B</CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME>Argument from Part to Whole</NAME>
      <FORM>
        <PREMISE>If A, then A is a part of B</PREMISE>
        <PREMISE>A</PREMISE>
        <CONCLUSION>B</CONCLUSION>
      </FORM>
    </SCHEME>
  </SCHEMESET>
</ARG>

