<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE ARG SYSTEM "argument.dtd">
<ARG>
  <SCHEMESET>
     <SCHEME>
      <NAME> Quasi-Logical Arguments. Contradiction and Incompability </NAME>
      <FORM>
        <PREMISE> A is contradictory or incompatible with B </PREMISE>
        <PREMISE> A (not A) </PREMISE>
        <CONCLUSION> Therefore not B (B) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Identity and definition </NAME>
      <FORM>
        <PREMISE> x is A </PREMISE>
        <PREMISE> A means that K, or A is the same as K </PREMISE>
        <CONCLUSION> x is K </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Analyticity </NAME>
      <FORM>
        <PREMISE> A </PREMISE>
        <PREMISE> Expression "A" is equivalent to expression "B" </PREMISE>
        <CONCLUSION> B </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. The Rule of Justice </NAME>
      <FORM>
        <PREMISE> A is (should be) applied to being or situation x1 </PREMISE>
        <PREMISE> x1 is the same kind as x2 </PREMISE>
        <CONCLUSION> A is (should be) applied to x2 </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Arguments of Reciprocity </NAME>
      <FORM>
        <PREMISE> x1 is A / In situation x1 A applies </PREMISE>
        <PREMISE> x2 is the counterpart (is symmetrical to) x1 </PREMISE>
        <CONCLUSION> x2 is (should be) A / In situation x2 A applies (should be applied) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Arguments by Transitivity </NAME>
      <FORM>
        <PREMISE> a is related to b by relation R </PREMISE>
        <PREMISE> b is related to c (or c is related to b) by relation R </PREMISE>
        <PREMISE> Relation R is transitive </PREMISE>
        <CONCLUSION> a is related to c by relation R </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Inclusion of the Part in the Whole </NAME>
      <FORM>
        <PREMISE> y is a species (part) of X </PREMISE>
        <PREMISE> X is A </PREMISE>
        <CONCLUSION> y is A (is less A, because it is a part; it is less A than x because it is a smaller part) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Division of the Whole into its Parts </NAME>
      <FORM>
        <PREMISE> X is the genus of x1, x2,...xn (x1, x2...xn are the parts of the whole X)</PREMISE>
        <PREMISE> Only if x1, or x2, or... xn is A, X is A. </PREMISE>
        <PREMISE> x1 is A (no x is A) </PREMISE>
        <CONCLUSION> X is A (X is not A) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Arguments by Comparison </NAME>
      <FORM>
        <PREMISE> x1 is equivalent (comparable) to x2 </PREMISE>
        <PREMISE> x2 is Q </PREMISE>
        <CONCLUSION> x1 is Q </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Argumentation by Sacrifice </NAME>
      <FORM>
        <PREMISE> For the thing x, sacrifice S is made </PREMISE>
        <PREMISE> Value V2 of x is proportional to the value (gravity) of sacrifice S  </PREMISE>
        <PREMISE> Sacrifice S is V1 (a value or gravity of the sacrifice) </PREMISE>
        <CONCLUSION> x is V2 (a value proportional to V1) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Quasi-Logical Arguments. Probabilities </NAME>
      <FORM>
        <PREMISE> If I do x, y will be more probable </PREMISE>
        <PREMISE> I am interested in y being more probable </PREMISE>
        <CONCLUSION> I should do x </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: causal Link 1 </NAME>
      <FORM>
        <PREMISE> Event x is successive to event y </PREMISE>
        <CONCLUSION> x causes y </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: causal Link 2 </NAME>
      <FORM>
        <PREMISE> y </PREMISE>
        <PREMISE> x causes y  </PREMISE>
        <CONCLUSION> x is the cause of y </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: causal Link 3  </NAME>
      <FORM>
        <PREMISE> Event x </PREMISE>
        <PREMISE> x causes y  </PREMISE>
        <CONCLUSION> If x happens, the consequence will be y </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: The Pragmatic Argument </NAME>
      <FORM>
        <PREMISE> Act or event x has the consequence(s) y </PREMISE>
        <PREMISE> y is favourable (unfavourable) </PREMISE>
        <CONCLUSION> x is good (bad) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: Ends and Means 1 </NAME>
      <FORM>
        <PREMISE> x is the means to the end y </PREMISE>
        <PREMISE> y is good (bad) </PREMISE>
        <CONCLUSION> x is good/less bad (bad) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: Ends and Means 2 </NAME>
      <FORM>
        <PREMISE> Means x should be regarded as an end (end x should be regarded as a means) </PREMISE>
        <CONCLUSION> x should (should not) be regarded as highly important </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: Ends and Means 3 </NAME>
      <FORM>
        <PREMISE> x is the means to the end y </PREMISE>
        <PREMISE> x is easy (not easy) to achieve </PREMISE>
        <CONCLUSION> y is good (bad) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: Argument of Waste </NAME>
      <FORM>
        <PREMISE> Person P has begun a task x and made sacrifices or efforts for it </PREMISE>
        <PREMISE> If P gave up task x, his sacrifices or efforts would be wasted </PREMISE>
        <CONCLUSION> P should not give up task x </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: Argument of Direction </NAME>
      <FORM>
        <PREMISE> Stage x of action leads to further stages y, z,...n </PREMISE>
        <PREMISE> n is not acceptable </PREMISE>
        <CONCLUSION> Stage x of action should not be brought about </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Sequential Relations: Unlimited Development </NAME>
      <FORM>
        <PREMISE> Stage of action or situation x leads to further stages or situations y, z,... </PREMISE>
        <PREMISE> Each stage or situation y, z ... is more valuable than its precedent one </PREMISE>
        <CONCLUSION> You should keep going in that direction </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: Interaction of Act and Person 1 </NAME>
      <FORM>
        <PREMISE> Person P has done acts A </PREMISE>
        <PREMISE> To acts A is attributed the value V </PREMISE>
        <CONCLUSION> Person P is V </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: Interaction of Act and Person 2 </NAME>
      <FORM>
        <PREMISE> Person P is V1 (a judgement value) </PREMISE>
        <PREMISE> If a person is V1, his acts A will be (are, were) V2 (judgement value depending on V1) </PREMISE>
        <CONCLUSION> P's acts A will be (are, were) V2 </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: Argument from Authority </NAME>
      <FORM>
        <PREMISE> Person P told A </PREMISE>
        <PREMISE> P is a men of influence </PREMISE>
        <CONCLUSION> A is highly acceptable </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: Argument from Expert Opinion </NAME>
      <FORM>
        <PREMISE> Person P told A </PREMISE>
        <PREMISE> P is an expert, has competence in a specific field which A belongs to </PREMISE>
        <CONCLUSION> A is highly acceptable </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: the Speech as an act of the Speaker 1 </NAME>
      <FORM>
        <PREMISE> Person P is V (judgement of value) </PREMISE>
        <PREMISE> P told W </PREMISE>
        <PREMISE> The judgement V affects the interpretation and therefore the evaluation of W (If V, therefore V1)  </PREMISE>
        <CONCLUSION> W is V1 </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: the Speech as an act of the Speaker 2 </NAME>
      <FORM>
        <PREMISE> Person P told W (judgement of value) </PREMISE>
        <PREMISE> W is good (bad) </PREMISE>
        <CONCLUSION> P is good (bad) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: the Group and its Members 1 </NAME>
      <FORM>
        <PREMISE> Member M of the group G has the quality Q </PREMISE>
        <PREMISE> If M has Q, G will have Q as well </PREMISE>
        <CONCLUSION> G has Q </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: the Group and its Members 2 </NAME>
      <FORM>
        <PREMISE> Group G has the quality Q </PREMISE>
        <PREMISE> M is a member (idea, habit, custom, product, method) of G </PREMISE>
        <PREMISE> If G has Q, his members M (ideas, habits, customs, products, methods) will have Q as well </PREMISE>
        <CONCLUSION> M is Q </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: Act and Essence 1 </NAME>
      <FORM>
        <PREMISE> x belongs to a structure, period, style...characterized by the essence E </PREMISE>
        <PREMISE> x has quality Q or does actions A </PREMISE>
        <CONCLUSION> x's quality or behaviour is explained by the essence E </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Relations of Coexistence: Act and Essence 2 </NAME>
      <FORM>
        <PREMISE> x belongs to a structure, period, style...characterized by the essence E </PREMISE>
        <PREMISE> x has quality Q or does actions A </PREMISE>
        <PREMISE> Q or A are in opposition with E </PREMISE>
        <CONCLUSION> x is exceptional/x distorted E </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Double Hierarchy Argument </NAME>
      <FORM>
        <PREMISE> Hierarchy H1 is correlated to hierarchy H2 </PREMISE>
        <PREMISE> y (an element on H1) is Q (an element on H2) </PREMISE>
        <PREMISE> x is lower (higher) than y on H1 </PREMISE>
        <CONCLUSION> Therefore x is Q' (lower (higher) than Q on H2) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> Arguments based on the Structure of Reality. Arguments concerning the differences of Degree and of Order </NAME>
      <FORM>
        <PREMISE> x belongs to a quantitative (qualitative) hierarchy, while y to a qualitative (quantitative) one </PREMISE>
        <PREMISE> x is showed as belonging to the same hierarchy y belongs to </PREMISE>
        <CONCLUSION> The difference of degree between x and y is minimized (is emphasized) </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> The relations establishing the Structure of reality. Establishment through the Particular case: Example </NAME>
      <FORM>
        <PREMISE> In this case, k has property F and property G </PREMISE>
        <PREMISE> k is typical of things that have F (is a typical member of class F) </PREMISE>
        <CONCLUSION> If x has property F (belongs to class F), x has property G </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> The relations establishing the Structure of reality. Establishment through the Particular case: Illustration  </NAME>
      <FORM>
        <PREMISE> Usually, if x has property F (belongs to class F), x has property G </PREMISE>
        <PREMISE> In this case, k has property F and property G </PREMISE>
        <CONCLUSION> The rule is valid </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> The relations establishing the Structure of reality. Establishment through the Particular case: Model </NAME>
      <FORM>
        <PREMISE> Individual P is prestigious for (admired by) individuals Q </PREMISE>
        <PREMISE> P carries out acts A </PREMISE>
        <PREMISE> If P carries out A, A are worth being imitated by Q </PREMISE>
        <CONCLUSION> Q should do A </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> The relations establishing the Structure of reality. Establishment through the Particular case: Anti-Model  </NAME>
      <FORM>
        <PREMISE> Individual P is not prestigious for (not admired by) individuals Q </PREMISE>
        <PREMISE> P carries out acts A </PREMISE>
        <PREMISE> Q wants to be different from P </PREMISE>
        <CONCLUSION> Q should not do A </CONCLUSION>
      </FORM>
    </SCHEME>
    <SCHEME>
      <NAME> The relations establishing the Structure of reality. Analogy </NAME>
      <FORM>
        <PREMISE> A is to B as C is to D </PREMISE>
        <PREMISE> C </PREMISE>
        <CONCLUSION> Therefore D </CONCLUSION>
      </FORM>
    </SCHEME>
  </SCHEMESET>
</ARG>


