<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE ARG SYSTEM "argument.dtd">
<ARG>
<SCHEMESET>


<SCHEME>

<NAME> Argument From Sign
</NAME>

<FORM>

<PREMISE>
A is true in this situation
</PREMISE>

<PREMISE>
Event B is generally indicated as true when its sign, A, is true in this kind of situation
</PREMISE>

<CONCLUSION>
B is true in this situation
</CONCLUSION>

</FORM>

<CQ>
What is the strength of the correlation between A and B
</CQ>

<CQ>
Are there any events other than B that would more reliably account for A?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Example
</NAME>

<FORM>

<PREMISE>
In this case, the individual a has property F and also property G
</PREMISE>

<PREMISE>
a is typical of things that have F and may or may not have G
</PREMISE>

<CONCLUSION>
Generally, if x has property F then (usually, probably, typically) x also has property G
</CONCLUSION>

</FORM>

<CQ>
Is it actually the case that a has F and G
</CQ>

<CQ>
Does the example of a actually support the general claim: is it really an
instance of the generalisation? </CQ>

<CQ>
Is a actually typical of the kinds of cases that the generalisation ranges over?
</CQ>

<CQ>
How strong, how widely applicable is the generalisation?
</CQ>

<CQ>
Are there special circumstances pertaining to a that impair its generalisability?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Verbal Classification
</NAME>

<FORM>

<PREMISE>
a has a particular property F
</PREMISE>

<PREMISE>
For all x, if x has property F, then x can be classified as having property G
</PREMISE>

<CONCLUSION>
a has property G
</CONCLUSION>

</FORM>

<CQ>
Does a definitely have F, or is there room for doubt?
</CQ>

<CQ>
Can the verbal classification be said to hold strongly, or is it a weak classification that is subject to doubt?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Commitment
</NAME>

<FORM>

<PREMISE>
a is commited to proposition A
</PREMISE>

<CONCLUSION>
In this case, a should support a
</CONCLUSION>

</FORM>

<CQ>
Is a really committed to A, and if so, what evidence supports the claim that she is so committed?
</CQ>

<CQ>
If the evidence for commitment is indirect or weak, could there also be contrary evidence, or at least room for the rebuttal that this case is an exception?
</CQ>

<CQ>
Is the proposition A cited in the premise identical to the proposition A cited in the conclusion? If not, what exactly is the relationship between the two propositions?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Circumstantial Argument Against the Person
</NAME>

<FORM>

<PREMISE>
If x claims that everyone (including x) ought to act in accord with, or support, proposition A, then x is, or should be, committed to A
</PREMISE>

<PREMISE>
a claims that everyone (including a) ought to act in accord with, or support, proposition A
</PREMISE>

<PREMISE>
It is indicated by a's personal circumstances that a is not committed to A
</PREMISE>

<CONCLUSION>
a is inconsistent in a's commitments, and there should be a weight of presumption against a's argument for a's claim.
</CONCLUSION>

</FORM>

<CQ>
Does a claim that everyone (including a) ought to act in accord with, or support, A?
</CQ>

<CQ>
What is the evidence from a's personal circumstances indicating he or she is not committed to A?
</CQ>

<CQ>
Does it follow from an affirmative answer to question 1 that a is, or should be commited to A?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Position to Know
</NAME>

<FORM>

<PREMISE>
a is in a position to know whether A is true (false)
</PREMISE>

<PREMISE>
a assets that A is true (false)
</PREMISE>

<CONCLUSION>
A is true (false)
</CONCLUSION>

</FORM>

<CQ>
Is a in a position to know whether A is true (false)?
</CQ>

<CQ>
Is a an honest (trustworthy, reliable) source?
</CQ>
 
<CQ>
Did a assert that A is true (false)?
</CQ>
 
</SCHEME>


<SCHEME>

<NAME> Argument from Expert Opinion
</NAME>

<FORM>

<PREMISE>
E is an expert in domain D
</PREMISE>

<PREMISE>
E asserts that A is known to be true
</PREMISE>

<PREMISE>
A is within D
</PREMISE>

<CONCLUSION>
A may (plausibly) be taken to be true.
</CONCLUSION>

</FORM>

<CQ>
Is E a genuine expert in D?
</CQ>

<CQ>
Did E really assert that A is known to be true?
</CQ>

<CQ>
Is the expert's pronouncement directly quoted? If not, is a reference to the original source given? Can it be checked?
</CQ>

<CQ>
If the expert advice is not quoted, does it look like important information or qualifications may have been left out?
</CQ>

<CQ>
If more than one expert source has been cited, is each authority quoted separately? Could there be disagreements among the cited authorities?
</CQ>

<CQ>
Is what the authority said clear? Are there technical terms used that are not explained clearly? If the advice is in layman's terms, could this be an indication that it has been translated from some other form of expression given by the expert?
</CQ>

<CQ>
Is A relevant to domain D?
</CQ>

<CQ>
Is A consistent with what other experts in D say?
</CQ>

<CQ>
Is A consistent with known evidence in D?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Evidence to a Hypothesis
</NAME>

<FORM>

<PREMISE>
If hypothesis A is true, then a proposition B, reporting an event, will be observed to be true.
</PREMISE>

<PREMISE>
B has been observed to be true in a given instance
</PREMISE>

<CONCLUSION>
A is true
</CONCLUSION>

</FORM>

<CQ>
Is it the case that if A is true, then B is true?
</CQ>

<CQ>
Has B been observed to be true (false)?
</CQ>

<CQ>
Could there be some other reason why B is true, other than its being because of A being true?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Falsification of a Hypothesis
</NAME>

<FORM>

<PREMISE>
If hypothesis A is true, then a proposition B, reporting an event, will be observed to be true.
</PREMISE>

<PREMISE>
B has been observed to be false in a given instance
</PREMISE>

<CONCLUSION>
A is false
</CONCLUSION>

</FORM>

</SCHEME>


<SCHEME>

<NAME> Argument from Correlation to Cause
</NAME>

<FORM>

<PREMISE>
There is a positive correlation between A nd B
</PREMISE>

<CONCLUSION>
A causes B
</CONCLUSION>

</FORM>

<CQ>
Is there a positive correlation between A and B?
</CQ>

<CQ>
Are there a significant number of instances of the positive correlation between A and B?
</CQ>

<CQ>
Is there good evidence that the causal relationship goes from A to B, and not just from B to A?
</CQ>

<CQ>
Can it be ruled out that the correlation between A and B is accounted for by some third factor (a common cause) that causes both A and B?
</CQ>

<CQ>
If there are intervening variables, can it be shown that the causal relationship between A and B is indirect (mediated through other causes)?
</CQ>

<CQ>
If the correlation fails to hold outside a certain range of causes, then can the limits of this range be clearly indicated?
</CQ>

<CQ>
Can it be shown that the increase or change in B is not solely due to the way B is defined, the way entities are classified as belonging to the class of Bs, or changing standards, over time, of the way Bs are defined or classified?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Cause to Effect
</NAME>

<FORM>

<PREMISE>
Generally, if A occurs, then B will (or might) occur
</PREMISE>

<PREMISE>
In this case, A occurs (or might occur)
</PREMISE>

<CONCLUSION>
In this case, B will (or might) occur
</CONCLUSION>

</FORM>

<CQ>
How strong is the causal generalization (if it is true at all)?
</CQ>

<CQ>
Is the evidence cited (if there is any) strong enough to warrant the generalization as stated?
</CQ>

<CQ>
Are there other factors that would or will interfere with or counteract the production of the effect in this case?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Consequences
</NAME>

<FORM>

<PREMISE>
If A is brought about, then good (bad) consequences will (may plausibly) occur
</PREMISE>

<CONCLUSION>
A should (not) be brought about
</CONCLUSION>

</FORM>

<CQ>
How strong is the likelihood that these cited consequences wil (may, must, etc.) occur?
</CQ>

<CQ>
If A is brought about, will (or might) these conequences occur, and what evidence supports this claim?
</CQ>

<CQ>
Are there consequences of the opposite value that should be taken into account?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Analogy
</NAME>

<FORM>

<PREMISE>
Generally, case C1 is similar to case C2
</PREMISE>

<PREMISE>
A is true (false) in case C1
</PREMISE>

<CONCLUSION>
A is true (false) in case C2
</CONCLUSION>

</FORM>

<CQ>
Are C1 and C2 similar in the respect cited?
</CQ>

<CQ>
Is A true (false) in C1
</CQ>

<CQ>
Are there differences between C1 and C2 that would tend to undermine the force of the similarity cited?
</CQ>

<CQ>
Is there some other case C3 that is also similar to C1, but in which A is false (true)?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Waste
</NAME>

<FORM>

<PREMISE>
If a stops trying to realize A now, all a's previous effors to realize A will be wasted
</PREMISE>

<PREMISE>
If all a's previous attempts to realize A are wasted, that would be a bad thing
</PREMISE>

<CONCLUSION>
a ought to continue trying to realize A
</CONCLUSION>

</FORM>

<CQ>
Are a's attempts to realize A really a negative value to be taken into account in any practical decision on what to do now, or are they simply past events that can no longer be changed?
</CQ>

<CQ>
Is there sufficient reason to think that if a continues, A will be realized? In other words, is A possible?
</CQ>

<CQ>
Is there good reason to think that, from this point, the value of realizing A is greater than the disvalue (cost) of continuing the process of attempting to realize A?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Popular Opinion
</NAME>

<FORM>

<PREMISE>
If a large majority (everyone, nearly everyone, etc.) accept A as true, then there exists a (defeasible) presumption in favour of A
</PREMISE>

<PREMISE>
A large majority accept A as true
</PREMISE>

<CONCLUSION>
There exists a presumption in favour of A
</CONCLUSION>

</FORM>

</SCHEME>


<SCHEME>

<NAME> Argument from Popular Practice
</NAME>

<FORM>

<PREMISE>
If a large majority (everyone, nearly everyone, etc.) does A, or acts as though A is the right (or an acceptable) thing to do, then A is a prudent course of action
</PREMISE>

<PREMISE>
A large majority acts as though A is the right thing to do
</PREMISE>

<CONCLUSION>
A is a prudent course of action
</CONCLUSION>

</FORM>

</SCHEME>


<SCHEME>

<NAME> Ethotic Argument
</NAME>

<FORM>

<PREMISE>
If x is a person of good (bad) moral character, then if x contends A, A should be accepted as more (less) plausible
</PREMISE>

<PREMISE>
a is a person of good (bad) moral character
</PREMISE>

<CONCLUSION>
if a contends A, A should be accepted as more (less) plausible
</CONCLUSION>

</FORM>

<CQ>
Is a a person of good moral character?
</CQ>

<CQ>
Is the question of a's character relevant, in the context of dialogue in the given case?
</CQ>

<CQ>
How strong a weight of presumption in favour of A is claimed, and is that strength warranted by the case?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Bias
</NAME>

<FORM>

<PREMISE>
If an arguer x is biased, then it is less likely that x has taken the evidence on both sides of an issue into account in arriving at conclusion A
</PREMISE>

<PREMISE>
Arguer a is biased
</PREMISE>

<CONCLUSION>
It is less likely that a has taken the evidence on both sides of the issue into account
</CONCLUSION>

</FORM>

<CQ>
What is the context of dialogue, and in particular, is it a type of dialogue that requires a participant to take evidence on both sides of an issue into account?
</CQ>

<CQ>
What is the evidence for the charge that a is biased?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from an Established Rule
</NAME>

<FORM>

<PREMISE>
For all x, if doing A is the established rule for x, then (subject to exceptional cases), x must do A (subject to penalty)
</PREMISE>

<PREMISE>
Doing A is the established rule for a
</PREMISE>

<CONCLUSION>
a must do A (subject to penalty)
</CONCLUSION>

</FORM>

<CQ>
Is doing A in fact what the rule states?
</CQ>

<CQ>
Does the rule doing A apply in this case?
</CQ>

<CQ>
Is the rule "For all x, x must do A" the right rule, or should some other rule be the right one? Could there be more than one rule involved, with some doubt on which is the more appropriate one?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from an Exceptional Case
</NAME>

<FORM>

<PREMISE>
For all x, if doing A is the established rule for x, then if the case of x is an exception, the rule does not apply to the case of x
</PREMISE>

<PREMISE>
Doing A is the established rule for a
</PREMISE>

<PREMISE>
The case of a is an exception
</PREMISE>

<CONCLUSION>
a need not do A
</CONCLUSION>

</FORM>

<CQ>
Is the case of a a recognized type of exception?
</CQ>

<CQ>
If it is not a recognized case, can evidence why the establised rule does not apply to it be given?
</CQ>

<CQ>
If it is a borderline case. can comparable cases be cited?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Precedent
</NAME>

<FORM>

<PREMISE>
The existing rule says that for all x, if x has property F then x has property G
</PREMISE>

<PREMISE>
But in this case C, a has property F, but does not have property G
</PREMISE>

<CONCLUSION>
The existing rule must be changed, qualified, r given up, or a new rule must be introduced to cover case C
</CONCLUSION>

</FORM>

<CQ>
Does the existing rule really say that for all x, if x has F then x has G?
</CQ>

<CQ>
Is case C legitimate, or can it be explained awy as not really in violation of the existing rule?
</CQ>

<CQ>
Is case C an already recognized type of exception that does not require any change in the exsisting rule?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Gradualism
</NAME>

<FORM>

<PREMISE>
Proposition A is true (acceptable to the respondent)
</PREMISE>

<PREMISE>
There is an intervening sequence of propositions, B1, B2, ..., Bn-1, Bn, C, such that the following conditionals are true: If A then B1; If B1 then B2; ...; If Bn-1 then Bn; If Bn then C
</PREMISE>

<PREMISE>
The conditional 'If A then C' is not, by itself, acceptable to the respondent (nor are any sequences from A to C shorter than the one specified in the second premise)
</PREMISE>

<CONCLUSION>
Proposition C is true (acceptable to the respondent)
</CONCLUSION>

</FORM>

</SCHEME>


<SCHEME>

<NAME> Causal Slippery Slope Argument
</NAME>

<FORM>

<PREMISE>
A0 is up for consideration as a proposal that seems initially like something that should be brough about
</PREMISE>

<PREMISE>
Bringing about A0 would plausibly cause (in the given circumstance, as far as we know) A1, which would in turn plausibly cause A2, and so forth, through the sequence A2, ..., An
</PREMISE>

<PREMISE>
An is a horrible (disastrous, bad) outcome
</PREMISE>

<CONCLUSION>
A0 should not be brough about
</CONCLUSION>

</FORM>

<CQ>
Does the proponent's description of the initial action A0 rightly express the proposal being advocated by the respondent?
</CQ>

<CQ>
Do any of the causal links in the sequence lack solid evidence to back it up as a clausal claim?
</CQ>

<CQ>
Does this outcome plausibly follow from the sequence, and is it as bad as the proponent suggests?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Precedent Slippery Slope Argument
</NAME>

<FORM>

<PREMISE>
Case C0 would set a precedent with respect to an existing rule R
</PREMISE>

<PREMISE>
Case C0 is similar to case C1, that is, if C0 is held to be an exception to R, then C1 must be held to be an exception too (in order to be consistent in treating equal cases alike). A sequence of similar pairs {Ci, Cj} binds us by case-to-case consistency to the series, C0, C1, ..., Cn
</PREMISE>

<PREMISE>
Having to accept case Cn as a precedent, or as a recgnized exception to R would be intolerable (horrid, bad)
</PREMISE>

<CONCLUSION>
Admitting case C0, or bringing it forward in the first place, is not a good thing to do
</CONCLUSION>

</FORM>

<CQ>
Would case C0 set a precedent?
</CQ>

<CQ>
What is the exact sequence of intervening steps in virtue of which case C0 would lead to Cn?
</CQ>

<CQ>
What is the evidence showing why each of these intervening steps would occur?
</CQ>

<CQ>
Is Cn intolerable, and if so why?
</CQ>

<CQ>
Which are the weakest of the intervening steps, and is the evidence backing them sufficient to warrant the strength of the claim made in the conclusion?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Vagueness of a Verbal Classification
</NAME>

<FORM>

<PREMISE>
Argument A occurs in a context of dialogue that requires a certain level of
precision appropriate
</PREMISE>

<PREMISE>
Some property F that occurs in argument A is defined in a way that is too
vague to meet the requirement of the level of precision appropriate for the
context of dialogue in which A occurs 
</PREMISE>

<PREMISE>
If an argument A occurs in a context of dialogue that requires a certain level
of precision, but some property F that occurs in A is defined in a way that is
too vague to meet the requriements of that level of precision, then A ought to
be rejected as deficient. 
</PREMISE>

<CONCLUSION>
Argument A ought to be rejected as deficient
</CONCLUSION>

</FORM>

<CQ>
Does the context of dialogue in which argument A occurs demand some particular
level of precision in the key terms used?
</CQ>

<CQ>
Is some property F that occurs in A too vague to meet the proper level or
standard of precision?
</CQ>

<CQ>
Why is this degree of vagueness a problem in relation to the dialogue in which
A was advanced?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Argument from Arbitrariness of a Verbal Classification
</NAME>

<FORM>

<PREMISE>
Argument A occurs in a context of dialogue that requires a
nonarbitrary definition for a key property F that occurs in A
</PREMISE>

<PREMISE>
Some property F that occurs in argument A is defined in a way that is
arbitrary
</PREMISE>

<PREMISE>
If an argument A occurs in a context of dialogue that requires a nonarbitrary
definition for a key property F that occurs in A, and F is defined in an
arbitrary way in A, then A ought to be rejected as deficient. 
</PREMISE>

<CONCLUSION>
Argument A ought to be rejected as deficient
</CONCLUSION>

</FORM>

<CQ>
Does the context of dialogue in which argument A occurs require a nonarbitrary
definition of F?
</CQ>

<CQ>
Is some property F that occurs in A defined in an arbitrary way?
</CQ>

<CQ>
Why is arbitrariness of definition a problem in relation to the dialogue in
which A was advanced?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Verbal Slippery Slope Argument
</NAME>

<FORM>

<PREMISE>
Individual a1 has property F
</PREMISE>

<PREMISE>
For all x and y, if x has F then, if y is indistinguishable for x with respect
to F, then y also has F 
</PREMISE>

<PREMISE>
For any given pair {ai, aj} of adjacent individuals in the sequence a1, a2,
..., an, individual aj is indistinguishable from ai with respect to F
</PREMISE>

<PREMISE>
But an does not have property F
</PREMISE>

<CONCLUSION>
It is not the case that a1 has F
</CONCLUSION>

</FORM>

<CQ>
Does a1 have F?
</CQ>

<CQ>
Is F really vague, in the sense that for all x and y, if x has F, then y must
also be conceded to have F?
</CQ>

<CQ>
Are the pairs {ai, aj} in the continuum really indistinguishable from each
other?
</CQ>

<CQ>
Is the conclusion that an does not have F truly the case (or at least is the
conclusion that an does have F truly unacceptable to the audience) ?
</CQ>

<CQ>
Can some precise definition of F be given that will remove the vagueness,
sufficiently to stop the slope?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Full Slippery Slope Argument
</NAME>

<FORM>

<PREMISE>
Case C0 is tentatively acceptable as an initial presumption
</PREMISE>

<PREMISE>
There exists a series of cases, C0, C1, ..., C(n-1), where each case leads to
the next by a combination of causal precedent, and/or analogy steps.
</PREMISE>

<PREMISE>
There is a climate of social opinion that once people come to accept each step
as plausible (or as accepted practice), they will then be led to accept the
next step.
</PREMISE>

<PREMISE>
The penultimate step C(n-1) leads to a horrible outcome, Cn, which is not
acceptable.
</PREMISE>

<CONCLUSION>
C0 is not acceptable
</CONCLUSION>

</FORM>

<CQ>
What are the various subarguments or links that make up the intervening steps
from C0 to Cn?
</CQ>

<CQ>
How strongly is the conclusion phrased, that is, what is the burden of proof
in the dialogue?
</CQ>

<CQ>
Is evidence given to back up each of the subarguments, and is it strong enough
to meet the requirements of burden of proof?
</CQ>

</SCHEME>


<SCHEME>

<NAME> Deductive Argument from Ignorance
</NAME>

<FORM>

<PREMISE>
All the true propositions in domain D of knowledge are contained in K
</PREMISE>

<PREMISE>
A is in D
</PREMISE>

<PREMISE>
A is not in K
</PREMISE>

<PREMISE>
For all A in D, A is either true or false
</PREMISE>

<CONCLUSION>
A is false
</CONCLUSION>

</FORM>

</SCHEME>


<SCHEME>

<NAME> Plausible Argument from Ignorance
</NAME>

<FORM>

<PREMISE>
It has not been established that all the true propositions in domain D of
knowledge are contained in K
</PREMISE>

<PREMISE>
A is a special type of proposition such that if A were true, A would normally
or usually be expected to be in K
</PREMISE>

<PREMISE>
A is in D
</PREMISE>

<PREMISE>
A is not in K
</PREMISE>

<PREMISE>
For all A in D, A is either true or false
</PREMISE>

<CONCLUSION>
A is false
</CONCLUSION>

</FORM>

</SCHEME>


</SCHEMESET>

</ARG>
